<?php

/**
 *
 * @author TopCMM daniel@topcmm.com
 * @copyright (c) 2010 TopCMM
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

/**
 * @ignore
 */
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();


if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

/*
 * The language file which will be included when installing
 * Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
 * $mod_name
 * 'INSTALL_' . $mod_name
 * 'INSTALL_' . $mod_name . '_CONFIRM'
 * 'UPDATE_' . $mod_name
 * 'UPDATE_' . $mod_name . '_CONFIRM'
 * 'UNINSTALL_' . $mod_name
 * 'UNINSTALL_' . $mod_name . '_CONFIRM'
 */
$language_file = 'mods/info_acp_fchat';

// The name of the mod to be displayed during installation.
$mod_name = 'ACP_FC';

/*
 * The name of the config variable which will hold the currently installed version
 * You do not need to set this yourself, UMIL will handle setting and updating the version itself.
 */
$version_config_name = 'fc_version';

/*
 * The array of versions and actions within each.
 * You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
 *
 * You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
 * The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
 */

$cat_module_data = array(
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'module_basename'	=> '',
	'module_langname'	=> '',
	'module_mode'		=> '',
	'module_langname'	=> 'ACP_CAT_FC',
	'module_auth'		=> 'acl_a_fchat',
);

// Insert Parent Module
$parent_module_data = array(
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'module_langname'	=> 'ACP_FC',
	'module_auth'		=> 'acl_a_fchat',
);

// Config Module
$config_module_data = array(
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'module_langname'	=> 'ACP_FC_CONFIG',
	'module_basename'	=> 'fchat',
	'module_mode'		=> 'config',
	'module_auth'		=> 'acl_a_fchat',
);

// Moreconfig Module
$moreconfig_module_data = array(
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'module_langname'	=> 'ACP_FC_MORECONFIG',
	'module_basename'	=> 'fchat',
	'module_mode'		=> 'moreconfig',
	'module_auth'		=> 'acl_a_fchat',
);
$versions = array(
// Version 2.1.0
	'2.1.0'	=> array(

		'config_add' => array(
array('fc_server', 2),
array('fc_status',1),
array('fc_room_list',1),
array('fc_user_list',1),
array('fc_client', 0),
array('fc_client_embed', 0),
array('fc_client_width', 779),
array('fc_client_height', 505),
array('fc_client_lang', 'en'),
array('fc_client_skin', 'default'),
array('fc_client_loc', ''),
array('fc_local_client_loc', ''),
array('fc_group', 'default'),
array('fc_api_url', ''),
array('fc_room', $config['server_name']),
array('fc_server_host', ''),
array('fc_server_port', 51127),
array('fc_http_port', 35555),
array('fc_show_live', 0),
array('fc_own_width', 700),
array('fc_own_height', 250),
array('fc_liveroom', 1),
array('fc_liveurl', ''),
array('fc_sty', 'default'),
),

		'table_add' => array(
array('phpbb_fchat', array(
					'COLUMNS'		=> array(
						'id'		        => array('UINT', NULL, 'auto_increment'),
						'user_id'			=> array('UINT', 255),
						'user_key'		    => array('XSTEXT_UNI', 255),
),
					'PRIMARY_KEY'	=> 'id',
),
),
),

		'permission_add' => array(
array('a_fchat'),
),

		'module_add' => array(
array('acp', '', $cat_module_data),
array('acp', 'ACP_CAT_FC', $parent_module_data),
array('acp', 'ACP_FC', $config_module_data),
array('acp', 'ACP_FC', $moreconfig_module_data),
),
),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>