<?php
/**
 *
 * @author TopCMM daniel@topcmm.com
 * @copyright (c) 2010 TopCMM
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */

/**
 * @ignore
 */
if (!defined('IN_PHPBB'))
{
	exit;
}
include($phpbb_root_path . 'includes/functions_requestRemote.' . $phpEx);

if (!function_exists('json_encode')) 
{
	include($phpbb_root_path . 'includes/functions_json.' . $phpEx);
	function json_encode($arg)
	{
		global $services_json;
		if (!isset($services_json)) 
		{
			$services_json = new Services_JSON();
		}
		return $services_json->encode($arg);
	}

	function json_decode($arg)
	{
		global $services_json;
		if (!isset($services_json)) 
		{
			$services_json = new Services_JSON();
		}
		$decodeObjects = $services_json->decode($arg);
		
		if(!empty($decodeObjects))
		{
			if(is_array($decodeObjects))
			{
				$decodeArray = array();
				foreach($decodeObjects as $objkey => $decodeObject)
				{
					if(is_object($decodeObject))
					{
						$decodeArray[$objkey] = array();
						foreach($decodeObject as $key => $val)
						{
							$decodeArray[$objkey][$key] = $val;
						}
					}
				}
			}
			else
			{
				$decodeArray = array();
				foreach($decodeObjects as $key => $val)
				{
					$decodeArray[$key] = $val;
				}
			}
		}
		return !empty($decodeArray) ? $decodeArray : false;
	}
}

function fc_get_chat_url()
{
	global $config;
	$client = $config['fc_client'];
	$server = $config['fc_server'];
	$client_name = $client ? (($client == 1) ? 'htmlchat/123flashchat.html' : 'avatarchat.swf') : '123flashchat.swf';
	if($config["fc_server"] == 0)
	{
		if(!empty($config['fc_local_client_loc']))
		{
			$chat_url = $config['fc_local_client_loc'] . $client_name . "?init_host=" . $config['fc_server_host'] . "&init_port=" . $config['fc_server_port'] . "&init_lang=" . $config['fc_client_lang'];
		}
		else
		{
			$chat_url = $config['fc_client_loc'] . $client_name . "?init_host=" . $config['fc_server_host'] . "&init_port=" . $config['fc_server_port'] . "&init_lang=" . $config['fc_client_lang'];
		}
	}
	else
	{
		$chat_url = $config['fc_client_loc'] . $client_name . "?init_host=" . $config['fc_server_host'] . "&init_port=" . $config['fc_server_port'] . "&init_lang=" . $config['fc_client_lang'];
	}
	if ($client == 0)
	{
		$chat_url .= "&init_skin=" . $config['fc_client_skin'];
	}
	if ($server == 1)
	{
		$chat_url .= "&init_group=" . $config['fc_group'];
	}
	return $chat_url;
}

function fc_get_status()
{
	global $config, $phpEx;
	$requestRemote = new topcmmRequestRemote();
	$data =   @file_get_contents("cache/status.js");
	$status_json = substr($data,10);
	
	if ((time() > substr($data,0,10)) || !$status_json || 1)
	{
		$server =  $config['fc_server'];
		switch ($server)
		{
			case 0:
				$status_js = $config['fc_api_url'] . "online.js";
				
				if($rs = $requestRemote->requestRemote($status_js))
				{
					$status_json = substr($rs,11,-1);
				}
				break;
			case 1:
				$status_js = $config['fc_api_url'] . "online.js?group=" . $config['fc_group'];
			
				if($rs = $requestRemote->requestRemote($status_js))
				{
					$status_json = substr($rs,11,-1);
				}
				break;
			case 2:
				$status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $config['fc_room'];
			
				if($rs = $requestRemote->requestRemote($status_js))
				{
					preg_match("/document.write\('(.*)'\);/",$rs,$matches);
					$status['ln'] = $matches[1];
					$status_json = json_encode($status);
				}
				break;
		}

		if($handle = @fopen("cache/status.js", "w+"))
		{
			@fwrite($handle, (time() + 300) .$status_json);
			@fclose($handle);
		}
	}
	
	return json_decode($status_json,true);
}


function fc_get_room_list()
{
	global $config;
	$requestRemote = new topcmmRequestRemote();
	$data =  @file_get_contents("cache/rooms.js");
	$rooms_json = substr($data,10);
	if ((time() > substr($data,0,10)) || !$rooms_json)
	{
		$server =  $config['fc_server'];
		switch ($server)
		{
			case 0:
				$room_js = $config['fc_api_url'] . "rooms.js";
				break;
			case 1:
				$room_js = $config['fc_api_url'] . "rooms.js?group=" . $config['fc_group'];
				break;
		}
		if($rs = $requestRemote->requestRemote($room_js))
		{
			$rooms_json = substr($rs,10,-1);
		}
		$requestRemote->requestRemote("cache/rooms.js",(time() + 300) . $rooms_json);
	}

	return json_decode($rooms_json, true);
}


function fc_get_user_list()
{
	global $config;
	$requestRemote = new topcmmRequestRemote();
	$data =  @file_get_contents("cache/users.js");

	$users_json = substr($data,10);
	if ((time() > substr($data,0,10)) || !$users_json)
	{
		$server =  $config['fc_server'];
		switch ($server)
		{
			case 0:
				$rooms = fc_get_room_list();
				$users = array();
				foreach ($rooms as $room)
				{
					$user_js = $config['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
					if($rs = $requestRemote->requestRemote($user_js))
					{
						$users = array_merge($users, json_decode(substr($rs,20,-1),true));
					}
				}
				$users_json = json_encode($users);
				break;
			case 1:
				$user_js = $config['fc_api_url'] . "roomonlineusers.js?group=" . $config['fc_group'];
				if($rs = $requestRemote->requestRemote($user_js))
				{
					$users_json = substr($rs,20,-1);
				}
				break;
			case 2:
				$user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $config['fc_room'];

				if($rs = $requestRemote->requestRemote($user_js))
				{
					preg_match("/document.write\('(.*)'\);/",$rs,$matches);
					foreach (explode(',', $matches[1]) as $user)
					{
						$users[] = array('name' => $user);
					}
				}
				$users_json = json_encode($users);
				break;
		}
		if($handle = @fopen("cache/users.js", "w+"))
		{
			@fwrite($handle, (time() + 300) .$users_json);
			@fclose($handle);
		}
	}

	return json_decode($users_json, true);
}
?>
